patch.sh 5.4 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191
  1. #!/usr/bin/env bash
  2. # Templates for next patch
  3. echo " === !! UNTESTED PATCH. CHECK FOR BANS USING A TRASH ACCOUNT !! ==="
  4. echo " === REPORT RESULTS TO THE MAIN REPOSITORY. THANK YOU. ==="
  5. echo ""
  6. echo "If you would like to test this patch, modify this script and remove the line below this one."
  7. exit 1
  8. #echo " === !! This patch is very new but almost identical to 1.5.1!! ==="
  9. #echo " === If you are worried, use a secondary account for a few days ==="
  10. #read -p "Continue? [Enter] " _dumpster_
  11. # MacOS and *BSD do not have md5sum: use md5 instead
  12. if [[ $(uname) == "Darwin" || $(uname) == *"BSD" ]]; then
  13. md5sum() {
  14. md5 -q $@
  15. }
  16. fi
  17. DIR=$(dirname "${BASH_SOURCE[0]}")
  18. DATADIR=$(find -type d -name "*_Data")
  19. FILE="UnityPlayer.dll"
  20. CEXE1="$DATADIR/upload_crash.exe"
  21. CEXE2="$DATADIR/Plugins/crashreport.exe"
  22. sum=($(md5sum $FILE))
  23. reltype=""
  24. # original hashes
  25. if [ "${sum}" == "af82a646e947d2ba69bf0c7f2432454a" ]; then
  26. reltype="os"
  27. echo "--- Applying for: International (OS) version"
  28. fi
  29. if [ "${sum}" == "688800bf397aaf1d088116d2ff267bb8" ]; then
  30. reltype="cn"
  31. echo "--- Applying for: Chinese (CN) version"
  32. fi
  33. if [ -z "$reltype" ]; then
  34. # The patch might corrupt invalid/outdated files if this check is skippd.
  35. echo "[ERROR] Wrong file version or the patch is already applied"
  36. echo " -> md5sum: ${sum}" && exit 1
  37. fi
  38. # =========== DO NOT REMOVE START ===========
  39. if [[ -e "$DIR/$FILE" ]]; then
  40. # There is a good reason for this check. Do not pollute the game directory.
  41. echo "[ERROR] Invalid patch download directory. Please move all"
  42. echo " patch files outside the game directory prior executing."
  43. echo " -> See README.md for proper installation instructions" && exit 1
  44. fi
  45. # =========== DO NOT REMOVE END ===========
  46. if ! command -v xdelta3 &>/dev/null; then
  47. echo "[ERROR] xdelta3 application is required"
  48. echo " -> Debian/Ubuntu: apt install xdelta3"
  49. echo " -> Fedora: dnf install xdelta"
  50. echo " -> Arch/Arch-based: pacman -S xdelta3"
  51. echo " -> macOS: \"port install xdelta\" or \"brew install xdelta\""
  52. exit 1
  53. fi
  54. # ===========================================================
  55. echo ""
  56. echo "[WARNING] Hereby you are violating the game's Terms of Service!"
  57. echo " Do you accept the risk and possible consequences?"
  58. read -p "Accept? [y/n] " choice
  59. if [[ ! "$choice" == [JjSsYy]* ]]; then
  60. exit 1
  61. fi
  62. echo
  63. echo "--- Setting up blocked servers"
  64. # START OF SUDO DANGER ZONE
  65. etc_hosts="$(cat /etc/hosts)"
  66. # See dev_tools/network.md (up-to-date as of 2.6.0)
  67. if [[ "$reltype" == "os" ]]; then
  68. servers=$(cat <<EOF
  69. # Genshin logging servers (do not remove!)
  70. 0.0.0.0 log-upload-os.mihoyo.com
  71. 0.0.0.0 overseauspider.yuanshen.com
  72. EOF
  73. )
  74. else
  75. servers=$(cat <<EOF
  76. # Genshin logging servers (do not remove!)
  77. 0.0.0.0 log-upload.mihoyo.com
  78. 0.0.0.0 uspider.yuanshen.com
  79. EOF
  80. )
  81. fi
  82. if [[ ! "$etc_hosts" == *"$servers"* ]]; then
  83. echo "[MANDATORY] Adding following logging servers to /etc/hosts"
  84. echo " If you really really want to skip this (Ctrl+C),"
  85. echo " PLEASE add the entries manually. Otherwise they will receive"
  86. echo " logs about The Wine project, hence UNCOVERING THIS PATCH!"
  87. echo "$servers" | sudo -k tee -a /etc/hosts
  88. if [ $? -ne 0 ]; then
  89. echo "$servers"
  90. read -p "Please append these lines to your /etc/hosts file now. Enter to continue."
  91. fi
  92. else
  93. echo "--- Logging servers are already blocked. Skip."
  94. fi
  95. servers=$(cat <<EOF
  96. # Optional Unity proxy/cdn servers
  97. 0.0.0.0 prd-lender.cdp.internal.unity3d.com
  98. 0.0.0.0 thind-prd-knob.data.ie.unity3d.com
  99. 0.0.0.0 thind-gke-usc.prd.data.corp.unity3d.com
  100. 0.0.0.0 cdp.cloud.unity3d.com
  101. 0.0.0.0 remote-config-proxy-prd.uca.cloud.unity3d.com
  102. EOF
  103. )
  104. if [[ ! "$etc_hosts" == *"$servers"* ]]; then
  105. echo ""
  106. echo "[Optional] Adding common Unity proxy/cdn servers to /etc/hosts"
  107. echo " Normally this does not cause any issues. If issues arise in other games,"
  108. echo " consider commenting a few lines to check what makes the difference."
  109. read -p "Add 5 servers? [y/n] " choice
  110. if [[ "$choice" == [JjSsYy]* ]]; then
  111. echo "-- Adding proxy/cdn servers"
  112. echo "$servers" | sudo tee -a /etc/hosts
  113. if [ $? -ne 0 ]; then
  114. read -p "--- FAILED to add the servers. Enter to continue."
  115. fi
  116. fi
  117. else
  118. echo "--- Unity proxy/cdn servers are already blocked. Skip."
  119. fi
  120. etc_hosts=""
  121. # END OF SUDO DANGER ZONE
  122. echo ""
  123. # No crashes shall be reported!
  124. echo "--- Renaming the crash reporter(s)"
  125. if [[ -e "$CEXE1" ]]; then
  126. # Replace existing backups
  127. mv -f "$CEXE1" "$CEXE1.bak"
  128. fi
  129. if [[ -e "$CEXE2" ]]; then
  130. mv -f "$CEXE2" "$CEXE2.bak"
  131. fi
  132. # Registry entry to add on startup
  133. cp -f "$DIR/patch_files/mhyprot2_running.reg" .
  134. # Add launcher & force update to ensure the checks are performed
  135. echo "--- Adding launcher script"
  136. cp -f "$DIR/patch_files/launcher.bat" .
  137. if [[ "$reltype" == "cn" ]]; then
  138. # Same thing but different
  139. sed -i "s/GenshinImpact/YuanShen/g" "launcher.bat"
  140. sed -i "s/log-upload-os/log-upload/g" "launcher.bat"
  141. sed -i "s/overseauspider/uspider/g" "launcher.bat"
  142. fi
  143. # Do the patch now, replace existing backups (hash confirmed)
  144. echo "--- Patching UnityPlayer"
  145. xdelta_fail() {
  146. mv -vf "$FILE.bak" "$FILE"
  147. exit 1
  148. }
  149. mv -f "$FILE" "$FILE.bak"
  150. # Perform patch or restore .bak on failure
  151. xdelta3 -d -s "$FILE.bak" "$DIR/patch_files/unityplayer_patch_${reltype}.vcdiff" "$FILE" || xdelta_fail
  152. # Done!
  153. echo "==> Patch applied! Enjoy the game."
  154. echo
  155. echo "[NOTICE] Please refrain from sharing this project in public so"
  156. echo " that there can be Linux patches in the future. Thank you."
  157. exit 0